MONGOSTAT(1)

NAME
mongostat - MongoDB Use Statistics

SYNOPSIS

The mongostat utility provides a quick overview of the status of a currently running mongod or mongos instance. mongostat is functionally similar to the UNIX/Linux file system utility vmstat, but provides data regarding mongod and mongos instances.

SEE ALSO: For more information about monitoring MongoDB, see http://docs.mongodb.org/manual/administration/monitoring.

For more background on various other MongoDB status outputs see:

•   http://docs.mongodb.org/manual/reference/command/serverStatus

•   http://docs.mongodb.org/manual/reference/command/replSetGetStatus

•   http://docs.mongodb.org/manual/reference/command/dbStats

•   http://docs.mongodb.org/manual/reference/command/collStats

    For an additional utility that provides MongoDB metrics see mongotop.

ACCESS CONTROL REQUIREMENTS

In order to connect to a mongod that enforces authorization with the --auth option, specify the --username and --password options, and the user specified must have the serverStatus privilege action on the cluster resources.

The built-in role clusterMonitor provides this privilege as well as other privileges. To create a role with just the privilege to run mongostat, see create-role-for-mongostat.

OPTIONS

mongostat

mongostat

--help
    Returns information on the options and use of mongostat.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--version
    Returns the mongostat release number.

--host <hostname><:port>, -h <hostname><:port>
    Default: localhost:27017

    Specifies a resolvable hostname for the mongod to which to connect. By default, the mongostat attempts to connect to a MongoDB instance running on the localhost on port number 27017.

    To connect to a replica set, specify the replSetName and a seed list of set members, as in the following:

    <replSetName>/<hostname1><:port>,<hostname2><:port>,<...>

    You can always connect directly to a single MongoDB instance by specifying the host and port number directly.

    Changed in version 3.0.0: If you use IPv6 and use the <address>:<port> format, you must enclose the portion of an address and port combination in brackets (e.g. [<address>]).

--port <port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

--ipv6
    Enables IPv6 support and allows the mongostat to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes disable IPv6 support by default.

--ssl
    New in version 2.6.

    Enables connection to a mongod or mongos that has SSL support enabled.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

    WARNING: If the mongo shell or any other tool that connects to mongos or mongod is run without --sslCAFile, it will not attempt to validate server certificates. This results in vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. Ensure that you always specify the CA file against which server certificates should be validated in cases where intrusion is a possibility.

--sslPEMKeyFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has CAFile enabled without allowConnectionsWithoutCertificates.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongostat will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongostat will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCRLFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in SSL certificates. Allows mongostat to connect to MongoDB instances if the hostname their certificates do not match the specified hostname.

--sslFIPSMode
    New in version 2.6.

    Directs the mongostat to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use the --sslFIPSMode option.

    NOTE: FIPS Compatible SSL is available only in MongoDB Enterprise. See http://docs.mongodb.org/manual/tutorial/configure-fips for more information.

--username <username>, -u <username>
    Specifies a username with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --password and --authenticationDatabase options.

--password <password>, -p <password>
    Specifies a password with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --username and --authenticationDatabase options.

    If you do not specify an argument for --password, mongostat will prompt interactively for a password on the console.

--authenticationDatabase <dbname>
    New in version 2.4.

    Specifies the database that holds the user's credentials.

    --authenticationDatabase is required for mongod and mongos instances that use authentication.

--authenticationMechanism <name>
    Default: MONGODB-CR

    New in version 2.4.

    Changed in version 2.6: Added support for the PLAIN and MONGODB-X509 authentication mechanisms.

    Specifies the authentication mechanism the mongostat instance uses to authenticate to the mongod or mongos.
    Value | Description
    MONGODB-CR | MongoDB challenge/response authentication.
    MONGODB-X509 | MongoDB SSL certificate authentication.
    PLAIN | External authentication using LDAP. You can also use PLAIN for authenticating in-database users. PLAIN transmits passwords in plain text. This mechanism is available only in MongoDB Enterprise.
    GSSAPI | External authentication using Kerberos. This mechanism is available only in MongoDB Enterprise.

--gssapiServiceName
    New in version 2.6.

    Specify the name of the service using GSSAPI/Kerberos. Only required if the service does not use the default name of mongodb.

    This option is available only in MongoDB Enterprise.

--gssapiHostName
    New in version 2.6.

    Specify the hostname of a service using GSSAPI/Kerberos. Only required if the hostname of a machine does not match the hostname resolved by DNS.

    This option is available only in MongoDB Enterprise.

--noheaders
    Disables the output of column or field names.

--rowcount <number>, -n <number>
    Controls the number of rows to output. Use in conjunction with the sleeptime argument to control the duration of a mongostat operation.

    Unless --rowcount is specified, mongostat will return an infinite number of rows (e.g. value of 0.)

--http
    Configures mongostat to collect data using the HTTP interface rather than a raw database connection.

--discover
    Discovers and reports on statistics from all members of a replica set or sharded cluster. When connected to any member of a replica set, --discover all non-hidden members of the replica set. When connected to a mongos, mongostat will return data from all shards in the cluster. If a replica set provides a shard in the sharded cluster, mongostat will report on non-hidden members of that replica set.

    The mongostat --host option is not required but potentially useful in this case.

    Changed in version 2.6: When running with --discover, mongostat now respects :option:--rowcount`.

--all
    Configures mongostat to return all optional fields.

--json
    New in version 3.0.0.

    Returns output for mongostat in JSON format.

<sleeptime>
    The final argument is the length of time, in seconds, that mongostat waits in between calls. By default mongostat returns one call every second.

    mongostat returns values that reflect the operations over a 1 second period. For values of <sleeptime> greater than 1, mongostat averages data to reflect average operations per second.

FIELDS

mongostat returns values that reflect the operations over a 1 second period. When mongostat <sleeptime> has a value greater than 1, mongostat averages the statistics to reflect average operations per second.

mongostat outputs the following fields:

inserts
    The number of objects inserted into the database per second. If followed by an asterisk (e.g. *), the datum refers to a replicated operation.

query
    The number of query operations per second.

update
    The number of update operations per second.

delete
    The number of delete operations per second.

getmore
    The number of get more (i.e. cursor batch) operations per second.

command
    The number of commands per second. On slave and secondary systems, mongostat presents two values separated by a pipe character (e.g. |), in the form of local|replicated commands.

flushes
    The number of fsync operations per second.

mapped
    The total amount of data mapped in megabytes. This is the total data size at the time of the last mongostat call.

size
    The amount of virtual memory in megabytes used by the process at the time of the last mongostat call.

non-mapped
    The total amount of virtual memory excluding all mapped memory at the time of the last mongostat call.

res The amount of resident memory in megabytes used by the process at the time of the last mongostat call.

faults
    Changed in version 2.1.

    The number of page faults per second.

    Before version 2.1 this value was only provided for MongoDB instances running on Linux hosts.

locked
    The percent of time in a global write lock.

    Changed in version 2.2: The locked db field replaces the locked % field to more appropriate data regarding the database specific locks in version 2.2.

locked db
    New in version 2.2.

    The percent of time in the per-database context-specific lock. mongostat will report the database that has spent the most time since the last mongostat call with a write lock.

    This value represents the amount of time that the listed database spent in a locked state combined with the time that the mongod spent in the global lock. Because of this, and the sampling method, you may see some values greater than 100%.

idx miss
    The percent of index access attempts that required a page fault to load a btree node. This is a sampled value.

qr  The length of the queue of clients waiting to read data from the MongoDB instance.

qw  The length of the queue of clients waiting to write data from the MongoDB instance.

ar  The number of active clients performing read operations.

aw  The number of active clients performing write operations.

netIn
    The amount of network traffic, in bytes, received by the MongoDB instance.

    This includes traffic from mongostat itself.

netOut
    The amount of network traffic, in bytes, sent by the MongoDB instance.

    This includes traffic from mongostat itself.

conn
    The total number of open connections.

set The name, if applicable, of the replica set.

repl
    The replication status of the member.
    Value | Replication Type
    M | master
    SEC | secondary
    REC | recovering
    UNK | unknown
    SLV | slave
    RTR | mongos process ("router")

USAGE

In the first example, mongostat will return data every second for 20 seconds. mongostat collects data from the mongod instance running on the localhost interface on port 27017. All of the following invocations produce identical behavior:

mongostat --rowcount 20 1
mongostat --rowcount 20
mongostat -n 20 1
mongostat -n 20

In the next example, mongostat returns data every 5 minutes (or 300 seconds) for as long as the program runs. mongostat collects data from the mongod instance running on the localhost interface on port 27017. Both of the following invocations produce identical behavior.

mongostat --rowcount 0 300
mongostat -n 0 300
mongostat 300

In the following example, mongostat returns data every 5 minutes for an hour (12 times.) mongostat collects data from the mongod instance running on the localhost interface on port 27017. Both of the following invocations produce identical behavior.

mongostat --rowcount 12 300
mongostat -n 12 300

In many cases, using the --discover will help provide a more complete snapshot of the state of an entire group of machines. If a mongos process connected to a sharded cluster is running on port 27017 of the local machine, you can use the following form to return statistics from all members of the cluster:

mongostat --discover

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2015